Index: trunk/src/lib/coord/p_node.cc
===================================================================
--- trunk/src/lib/coord/p_node.cc	(revision 6042)
+++ trunk/src/lib/coord/p_node.cc	(revision 6048)
@@ -26,5 +26,4 @@
 #include "error.h"
 #include "debug.h"
-#include "list.h"
 #include "vector.h"
 
@@ -35,5 +34,5 @@
 
 /**
- *  standard constructor
+ * @brief standard constructor
  */
 PNode::PNode ()
@@ -57,5 +56,5 @@
 
 /**
- *  constructor with coodinates
+ * @brief constructor with coodinates
  * @param absCoordinate the Absolute coordinate of the Object
  * @param parent The parent-node of this node.
@@ -72,5 +71,5 @@
 
 /**
- * standard deconstructor
+ * @brief standard deconstructor
  *
  * There are two general ways to delete a PNode
@@ -110,5 +109,5 @@
 
 /**
- *  initializes a PNode
+ * @brief initializes a PNode
  * @param parent the parent for this PNode
  */
@@ -129,5 +128,5 @@
 
 /**
- *  loads parameters of the PNode
+ * @brief loads parameters of the PNode
  * @param root the XML-element to load the properties of
  */
@@ -168,5 +167,5 @@
 
 /**
- *  set relative coordinates
+ * @brief set relative coordinates
  * @param relCoord relative coordinates to its parent
  *
@@ -189,5 +188,5 @@
 
 /**
- *  set relative coordinates
+ * @brief set relative coordinates
  * @param x x-relative coordinates to its parent
  * @param y y-relative coordinates to its parent
@@ -201,5 +200,5 @@
 
 /**
- * sets a new relative position smoothely
+ * @brief sets a new relative position smoothely
  * @param relCoordSoft the new Position to iterate to
  * @param bias how fast to iterate to this position
@@ -216,5 +215,5 @@
 
 /**
- *  set relative coordinates smoothely
+ * @brief set relative coordinates smoothely
  * @param x x-relative coordinates to its parent
  * @param y y-relative coordinates to its parent
@@ -299,5 +298,5 @@
 
 /**
- *  shift coordinate relative
+ * @brief shift coordinate relative
  * @param shift shift vector
  *
@@ -323,5 +322,5 @@
 
 /**
- *  set relative direction
+ * @brief set relative direction
  * @param relDir to its parent
  */
@@ -353,5 +352,5 @@
 
 /**
- * sets the Relative Direction of this node to its parent in a Smoothed way
+ * @brief sets the Relative Direction of this node to its parent in a Smoothed way
  * @param relDirSoft the direction to iterate to smoothely.
  * @param bias how fast to iterate to the new Direction
@@ -381,5 +380,5 @@
 
 /**
- *  sets the absolute direction
+ * @brief sets the absolute direction
  * @param absDir absolute coordinates
  */
@@ -414,6 +413,7 @@
 
 /**
- * sets the absolute direction
+ * @brief sets the absolute direction
  * @param absDir absolute coordinates
+ * @param bias how fast to iterator to the new Position
  */
 void PNode::setAbsDirSoft (const Quaternion& absDirSoft, float bias)
@@ -446,5 +446,5 @@
 
 /**
- * shift Direction
+ * @brief shift Direction
  * @param shift the direction around which to shift.
  */
@@ -455,6 +455,7 @@
 }
 
-/**
- *  adds a child and makes this node to a parent
+
+/**
+ * @brief adds a child and makes this node to a parent
  * @param child child reference
  * use this to add a child to this node.
@@ -473,4 +474,5 @@
 }
 
+
 /**
  * @see PNode::addChild(PNode* child);
@@ -484,6 +486,7 @@
 }
 
-/**
- *  removes a child from the node
+
+/**
+ * @brief removes a child from the node
  * @param child the child to remove from this pNode.
  *
@@ -501,5 +504,5 @@
 
 /**
- *  remove this pnode from the tree and adds all following to NullParent
+ * @brief remove this pnode from the tree and adds all following to NullParent
  *
  * this can be the case, if an entity in the world is being destroyed.
@@ -515,12 +518,4 @@
 }
 
-/**
- * sets the parent of this PNode
- * @param parent the Parent to set
- */
-void PNode::setParent (PNode* parent)
-{
-  parent->addChild(this);
-}
 
 /**
@@ -536,5 +531,5 @@
 
 /**
- * does the reparenting in a very smooth way
+ * @brief does the reparenting in a very smooth way
  * @param parentNode the new Node to connect this node to.
  * @param bias the speed to iterate to this new Positions
@@ -574,5 +569,5 @@
 
 /**
- * does the reparenting in a very smooth way
+ * @brief does the reparenting in a very smooth way
  * @param parentName the name of the Parent to reconnect to
  * @param bias the speed to iterate to this new Positions
@@ -585,6 +580,7 @@
 }
 
-/**
- *  sets the mode of this parent manually
+
+/**
+ * @brief sets the mode of this parent manually
  * @param parentMode a String representing this parentingMode
  */
@@ -595,5 +591,5 @@
 
 /**
- *  updates the absCoordinate/absDirection
+ * @brief updates the absCoordinate/absDirection
  * @param dt The time passed since the last update
  *
@@ -699,4 +695,8 @@
 
 
+/**
+ * @brief counts total amount the children walking through the entire tree.
+ * @param nodes the counter
+ */
 void PNode::countChildNodes(int& nodes) const
 {
@@ -709,5 +709,5 @@
 
 /**
- *  displays some information about this pNode
+ * @brief displays some information about this pNode
  * @param depth The deph into which to debug the children of this PNode to.
  * (0: all children will be debugged, 1: only this PNode, 2: this and direct children, ...)
@@ -754,5 +754,5 @@
 
 /**
- * displays the PNode at its position with its rotation as a cube.
+ * @brief displays the PNode at its position with its rotation as a cube.
  * @param  depth The deph into which to debug the children of this PNode to.
  * (0: all children will be displayed, 1: only this PNode, 2: this and direct children, ...)
@@ -856,5 +856,5 @@
 
 /**
- * converts a parentingMode into a string that is the name of it
+ * @brief converts a parentingMode into a string that is the name of it
  * @param parentingMode the ParentingMode to convert
  * @return the converted string
@@ -875,5 +875,5 @@
 
 /**
- * converts a parenting-mode-string into a int
+ * @brief converts a parenting-mode-string into a int
  * @param parentingMode the string naming the parentingMode
  * @return the int corresponding to the named parentingMode
Index: trunk/src/lib/coord/p_node.h
===================================================================
--- trunk/src/lib/coord/p_node.h	(revision 6042)
+++ trunk/src/lib/coord/p_node.h	(revision 6048)
@@ -43,5 +43,5 @@
   // REPARENTING
   PNODE_REPARENT_TO_NULLPARENT         = 0x0010,    //!< Reparents to the NullParent, if the Parent is Removed.
-  PNODE_REPARENT_TO_PARANTS_PARENT     = 0x0020,    //!< Reparents the Node to the parents (old) parent it the parent gets removed.
+  PNODE_REPARENT_TO_PARENTS_PARENT     = 0x0020,    //!< Reparents the Node to the parents (old) parent it the parent gets removed.
   PNODE_REPARENT_DELETE_CHILDREN       = 0x0040,    //!< Deletes the Children of the node when This Node is Removed. (Use with care).
   PNODE_REPARENT_KEEP_POSITION         = 0x0080,    //!< Tries to keep the Position if the Node is reparented.
@@ -51,5 +51,5 @@
   PNODE_PROHIBIT_CHILD_DELETE          = 0x0100,    //!< Prohibits the Children from being deleted if this Node gets deleted.
   PNODE_PROHIBIT_DELETE_WITH_PARENT    = 0x0200,    //!< Prohibits the Node to be deleted if the Parent is. Child will be reparented according to the Repaenting-Rules
-  PNODE_REPARENT_CHILDREN_ON_DELETE    = 0x0400,    //!< Reparents the Children of the Node to 
+  PNODE_REPARENT_CHILDREN_ON_DELETE    = 0x0400,    //!< Reparents the Children of the Node to
   PNODE_REPARANT_CHILDREN_ON_REMOVE    = 0x0800,    //!< Reparents the Children of the Node if the Node gets Removed.
 
@@ -132,5 +132,6 @@
   void removeNode();
 
-  void setParent (PNode* parent);
+  /** @param the new parent of this node */
+  inline void setParent (PNode* parent) { parent->addChild(this); };
   void setParent (const char* parentName);
   /** @returns the parent of this PNode */
@@ -169,4 +170,5 @@
   inline Vector getLastAbsCoor() { return this->lastAbsCoordinate; }
 
+  void reparent();
 
  private: